Scriptname Serio_HK_EquipItemsScript extends Quest  

Serio_HK_HotkeyMainScript MainScript
Actor Player
Event OnInit()
	Player = Game.Getplayer()
	MainScript = (Self as Quest) as Serio_HK_HotkeyMainScript
	RegisterForModEvent("Serio_HK_RunAsyncEquip", "OnRunAsyncEquip")
EndEvent

Function PlayerLoadGame()
	RegisterForModEvent("Serio_HK_RunAsyncEquip", "OnRunAsyncEquip")
EndFunction
;------- Thread Members, Functions, & Events --------------
Bool threadQueued
Form threadForm
String threadName
Int threadID
Int threadType
Int threadEquipSlot
Bool Function StoreThreadVariables(Int akIndex)
	threadQueued = True
	threadForm = JArray.getForm(MainScript.objEquipmentFormsArray, akIndex)
	threadName = JArray.getStr(MainScript.objEquipmentNamesArray, akIndex)
	threadID = JArray.getInt(MainScript.objEquipmentIDsArray, akIndex)
	threadType = JArray.getInt(MainScript.objEquipmentTypesArray, akIndex)
	threadEquipSlot = JArray.getInt(MainScript.objEquipmentSlotsArray, akIndex)
	;debug.trace(self + "Stored variables to thread: " + akList + iSlot)
	return True
EndFunction

Event OnRunAsyncEquip()
	If threadQueued
		If threadName == "Unequip Left"
			form kForm = Player.GetEquippedObject(0)
			If (kForm as spell)
				Player.UnequipSpell(kForm as spell,0)
			Else
				Player.UnequipItemEx(kForm,threadEquipSlot)
			EndIf
			debug.trace("tyring to unequip " + kForm.GetName())
		ElseIf threadName == "Unequip Right"
			form kForm = Player.GetEquippedObject(1)
			If (kForm as spell)
				Player.UnequipSpell(kForm as spell,1)
			Else
				Player.UnequipItemEx(kForm,threadEquipSlot)
			EndIf
			debug.trace("tyring to unequip " + kForm.GetName())
		ElseIf threadID && Player.GetItemCount(threadForm)
			Player.EquipItemByID(threadForm,threadID,threadEquipSlot)
			debug.trace("Trying to equip " + threadName + " by ID " + threadID + " on equipslot " + threadEquipSlot)
			If Player.IsEquipped(threadForm)
				debug.trace("Equipped " + threadName + " by ID " + threadID + " on equipslot " + threadEquipSlot)
			Else
				Player.EquipItemEx(threadForm,threadEquipSlot)
				debug.trace("Could not equip " + threadName + " by ID. Equipping by form instead.")
			EndIf	
		ElseIf threadType == MainScript.kSpell
			threadEquipSlot = ConvertItemSlotToSpellSlot(threadEquipSlot)
			If Player.HasSpell(threadForm)
				Player.EquipSpell((threadForm as spell),threadEquipSlot)
			EndIf
			debug.trace("Equipped " + threadName)
		ElseIf threadType == MainScript.kShout
			If Player.HasSpell(threadForm)
				Player.EquipShout(threadForm as Shout)
			EndIf
			debug.trace("Equipped " + threadName)
		ElseIf threadForm && Player.GetItemCount(threadForm)
			Player.EquipItemEx(threadForm,threadEquipSlot)
			debug.trace("Equipped " + threadName + " by form")
		EndIf
		ClearVariables()
		threadQueued = false
	EndIf
EndEvent

Int Function ConvertItemSlotToSpellSlot(int akSlot)
	If akSlot == 0
		return 2
	ElseIf akSlot == 1
		return 1
	ElseIf akSlot == 2
		return 0
	EndIf
EndFunction

Bool Function Queued()
	;debug.trace(threadQueued)
	return threadQueued
EndFunction

Bool Function ForceUnlock()
	ClearVariables()
	threadQueued = false
	return !threadQueued
EndFunction

Function ClearVariables()
	threadForm = None
	threadName = ""
	threadID = 0
	threadType = 0
	threadEquipSlot = 0
EndFunction