Scriptname Serio_HK_HotkeyMainScript extends Quest  

;---- Transformation Races
Race Werewolf
Race VampireLord
;============= INITIALIZE STUFF ================
UILib_1 UILib
Serio_HK_MCMScript MCMScript
Actor Player
Bool bInitLock
Function PlayerLoadGame()
	If !Player
		Player = Game.GetPlayer()
	EndIf
	If !Werewolf
		Werewolf = game.GetFormFromFile(0x0CDD84, "Skyrim.esm") as Race
	EndIf
	If !VampireLord
		VampireLord = game.GetFormFromFile(0x00283A, "Dawnguard.esm") as Race
	EndIf
	RegisterForModEvent("Serio_HK_HotkeySetterMenuOpen","OnHotkeySetterMenuOpen")
EndFunction

Event OnInit()
	If bInitLock
		return
	EndIf
	bInitLock = True
	Player = Game.Getplayer()
	InitializeContainers()
	InitializeThreads()
	Werewolf = game.GetFormFromFile(0x0CDD84, "Skyrim.esm") as Race
	VampireLord = game.GetFormFromFile(0x00283A, "Dawnguard.esm") as Race
	UILib = (Self as Form) as UILib_1
	MCMScript = (Self as Quest) as Serio_HK_MCMScript
	RegisterForModEvent("Serio_HK_HotkeySetterMenuOpen","OnHotkeySetterMenuOpen")
EndEvent

Serio_HK_EquipItemsThread01 Thread01
Serio_HK_EquipItemsThread02 Thread02
Serio_HK_EquipItemsThread03 Thread03
Serio_HK_EquipItemsThread04 Thread04
Serio_HK_EquipItemsThread05 Thread05
Serio_HK_EquipItemsThread06 Thread06
Serio_HK_EquipItemsThread07 Thread07
Serio_HK_EquipItemsThread08 Thread08
Serio_HK_EquipItemsThread09 Thread09
Serio_HK_EquipItemsThread10 Thread10
Function InitializeThreads()
	Thread01 = (Self as Quest) as Serio_HK_EquipItemsThread01
	Thread02 = (Self as Quest) as Serio_HK_EquipItemsThread02
	Thread03 = (Self as Quest) as Serio_HK_EquipItemsThread03 
	Thread04 = (Self as Quest) as Serio_HK_EquipItemsThread04 
	Thread05 = (Self as Quest) as Serio_HK_EquipItemsThread05 
	Thread06 = (Self as Quest) as Serio_HK_EquipItemsThread06 
	Thread07 = (Self as Quest) as Serio_HK_EquipItemsThread07 
	Thread08 = (Self as Quest) as Serio_HK_EquipItemsThread08 
	Thread09 = (Self as Quest) as Serio_HK_EquipItemsThread09 
	Thread10 = (Self as Quest) as Serio_HK_EquipItemsThread10 
EndFunction

Function InitializeContainers()
	objSerioHotkeyModData = JMap.Object()
	
	LoadWornItemArray()
	LoadEquipItemArray()
	
	objTempData = JMap.Object()
	;=== Create Custom Hotkey Data here ===
	objHotkeyData = JMap.Object()
	objCustomHotkeyData = JMap.Object()
	objHotkeyData = objCustomHotkeyData
	
	objHotkeyNamesArray = JArray.Object()
	objHotkeyMappingArray = JArray.Object()
	objHotkeyModifierMappingArray = JArray.Object() ;--- NEW
	objHotkeyCycleDataArray = JArray.Object()
	objHotkeyAtCurrentCycleArray = JArray.Object()
	
	While JValue.count(objHotkeyNamesArray) < 10
		CreateNewHotkey()
	EndWhile
	
	;=== Create Vanilla Hotkey Data here ===
	objVanillaHotkeyData = JMap.Object()
	objHotkeyData = objVanillaHotkeyData
	
	objHotkeyNamesArray = JArray.Object()
	objHotkeyMappingArray = JArray.Object()
	objHotkeyCycleDataArray = JArray.Object()
	objHotkeyAtCurrentCycleArray = JArray.Object()
	
	While JValue.count(objHotkeyNamesArray) < 8
		CreateNewVanillaHotkey()
	EndWhile
	
	;=== Set back to custom hotkey data ===
	objHotkeyData = objCustomHotkeyData
	
EndFunction

Function AddMoreHotkeys()
	Int i = 0
	While i < 10
		CreateNewHotkey()
		i += 1
	EndWhile
EndFunction
;==================== JCONTAINER PROPERTIES ===============================
int property objSerioHotkeyModData
	int Function get()
		return JDB.solveObj(".SerioHotkeyModData")
	EndFunction
	Function set(int objObject)
		JDB.setObj("SerioHotkeyModData",objObject)
	EndFunction
EndProperty

int property objCustomHotkeyData
	int Function get()
		return JMap.getObj(objSerioHotkeyModData,"CustomHotkeyData")
	EndFunction
	Function set(int objObject)
		JMap.setObj(objSerioHotkeyModData,"CustomHotkeyData",objObject)
	EndFunction
EndProperty

int property objVanillaHotkeyData
	int Function get()
		return JMap.getObj(objSerioHotkeyModData,"VanillaHotkeyData")
	EndFunction
	Function set(int objObject)
		JMap.setObj(objSerioHotkeyModData,"VanillaHotkeyData",objObject)
	EndFunction
EndProperty

int property objHotkeyData
	int Function get()
		return JMap.getObj(objSerioHotkeyModData,"HotkeyData")
	EndFunction
	Function set(int objObject)
		JMap.setObj(objSerioHotkeyModData,"HotkeyData",objObject)
	EndFunction
EndProperty

	int property objHotkeyNamesArray
		int Function get()
			return JMap.getObj(objHotkeyData,"HotkeyNamesArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objHotkeyData,"HotkeyNamesArray",objObject)
		EndFunction
	EndProperty
	
	int property objHotkeyMappingArray
		int Function get()
			return JMap.getObj(objHotkeyData,"HotkeyKeyMapArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objHotkeyData,"HotkeyKeyMapArray",objObject)
		EndFunction
	EndProperty
	
	int property objHotkeyModifierMappingArray ;--- NEW. Vanilla keys won't have this
		int Function get()
			return JMap.getObj(objHotkeyData,"HotkeyModifierMapArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objHotkeyData,"HotkeyModifierMapArray",objObject)
		EndFunction
	EndProperty
	
	int property objHotkeyCycleDataArray
		int Function get()
			return JMap.getObj(objHotkeyData,"HotkeyCycleDataArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objHotkeyData,"HotkeyCycleDataArray",objObject)
		EndFunction
	EndProperty
	
	int property objHotkeyAtCurrentCycleArray
		int Function get()
			return JMap.getObj(objHotkeyData,"HotkeyAtCurrentCycleArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objHotkeyData,"HotkeyAtCurrentCycleArray",objObject)
		EndFunction
	EndProperty
	
int property objTempData ; reset this with JMap.Object() to append its contents back to their proper references.
	int Function get()
		return JMap.getObj(objSerioHotkeyModData,"TempData")
	EndFunction
	Function set(int objObject)
		JMap.setObj(objSerioHotkeyModData,"TempData",objObject)
	EndFunction
EndProperty
	
int property objCycleData
	int Function get()
		return JMap.getObj(objTempData,"CycleData")
	EndFunction
	Function set(int objObject)
		JMap.setObj(objTempData,"CycleData",objObject)
	EndFunction
EndProperty

	int property objCycleNameArray
		int Function get()
			return JMap.getObj(objCycleData,"CycleNameArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objCycleData,"CycleNameArray",objObject)
		EndFunction
	EndProperty
	
	int property objCycleEquipsetDataArray
		int Function get()
			return JMap.getObj(objCycleData,"CycleEquipsetDataArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objCycleData,"CycleEquipsetDataArray",objObject)
		EndFunction
	EndProperty
	
	int property objCycleUnequipAllPriorArray
		int Function get()
			return JMap.getObj(objCycleData,"CycleUnequipAllPriorArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objCycleData,"CycleUnequipAllPriorArray",objObject)
		EndFunction
	EndProperty
	
int property objWornItemSlotMaskReferenceArray
	int Function get()
		return JMap.getObj(objSerioHotkeyModData,"WornItemSlotReferenceArray")
	EndFunction
	Function set(int objObject)
		JMap.setObj(objSerioHotkeyModData,"WornItemSlotReferenceArray",objObject)
	EndFunction
EndProperty

int property objEquipItemSlotReferenceArray
	int Function get()
		return JMap.getObj(objSerioHotkeyModData,"EquipItemSlotReferenceArray")
	EndFunction
	Function set(int objObject)
		JMap.setObj(objSerioHotkeyModData,"EquipItemSlotReferenceArray",objObject)
	EndFunction
EndProperty

int property objEquipsetData
	int Function get()
		return JMap.getObj(objTempData,"EquipsetData")
	EndFunction
	Function set(int objObject)
		JMap.setObj(objTempData,"EquipsetData",objObject)
	EndFunction
EndProperty

	int property objEquipmentNamesArray
		int Function get()
			return JMap.getObj(objEquipsetData,"EquipmentNamesArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objEquipsetData,"EquipmentNamesArray",objObject)
		EndFunction
	EndProperty
	
	int property objEquipmentFormsArray
		int Function get()
			return JMap.getObj(objEquipsetData,"EquipmentFormsArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objEquipsetData,"EquipmentFormsArray",objObject)
		EndFunction
	EndProperty
	
	int property objEquipmentIDsArray
		int Function get()
			return JMap.getObj(objEquipsetData,"EquipmentIDsArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objEquipsetData,"EquipmentIDsArray",objObject)
		EndFunction
	EndProperty
	
	int property objEquipmentTypesArray
		int Function get()
			return JMap.getObj(objEquipsetData,"EquipmentTypesArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objEquipsetData,"EquipmentTypesArray",objObject)
		EndFunction
	EndProperty
	
	int property objEquipmentSlotsArray
		int Function get()
			return JMap.getObj(objEquipsetData,"EquipmentSlotsArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objEquipsetData,"EquipmentSlotsArray",objObject)
		EndFunction
	EndProperty

int property objCurrentEquipmentCacheData
	int Function get()
		return JMap.getObj(objTempData,"CurrentEquipmentCacheData")
	EndFunction
	Function set(int objObject)
		JMap.setObj(objTempData,"CurrentEquipmentCacheData",objObject)
	EndFunction
EndProperty

	int property objCurrentEquipmentCacheNamesArray
		int Function get()
			return JMap.getObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheNamesArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheNamesArray",objObject)
		EndFunction
	EndProperty
	
	int property objCurrentEquipmentCacheFormsArray
		int Function get()
			return JMap.getObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheFormsArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheFormsArray",objObject)
		EndFunction
	EndProperty
	
	int property objCurrentEquipmentCacheIDsArray
		int Function get()
			return JMap.getObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheIDsArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheIDsArray",objObject)
		EndFunction
	EndProperty
	
	int property objCurrentEquipmentCacheTypesArray
		int Function get()
			return JMap.getObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheTypesArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheTypesArray",objObject)
		EndFunction
	EndProperty
	
	int property objCurrentEquipmentCacheSlotsArray
		int Function get()
			return JMap.getObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheSlotsArray")
		EndFunction
		Function set(int objObject)
			JMap.setObj(objCurrentEquipmentCacheData,"CurrentEquipmentCacheSlotsArray",objObject)
		EndFunction
	EndProperty

;=================== HOTKEY EXECUTION FUNCTIONS & EVENTS =====================
Int ReservedIndex = -1
Int ReservedKeypressCount = 0
Int CurrentIndex
Bool ThreadsProcessing
Function ExecuteHotkey(int akIndex)
	If (Player.GetRace() == VampireLord) || (Player.GetRace() == Werewolf)
		return
	EndIf
	
	If ThreadsProcessing 
	;Rather than equipping at every single keypress, we simply cache the last pressed index and number of times key was pressed, then call function again if there is a reserved index. This makes spamming without processing lag possible.
		If (akIndex != CurrentIndex) || (akIndex != ReservedIndex)
			ReservedKeypressCount = 0 ;Reset reserved count if different hotkey is pressed.
		EndIf
		ReservedIndex = akIndex
		ReservedKeypressCount += 1
		;debug.trace("storing reserve at index " + ReservedIndex)
		Return
	EndIf
	ThreadsProcessing = True
	UnregisterForUpdate()
	CurrentIndex = akIndex
	objCycleData = JArray.getObj(objHotkeyCycleDataArray,CurrentIndex)
	Int iMaxCycles = (JValue.count(objCycleNameArray) - 1) ; -1 because there's always an empty cycle
	;debug.trace("thinks there max cycles are " + iMaxCycles)
	Int iCurrentCycle = JArray.getInt(objHotkeyAtCurrentCycleArray,CurrentIndex) + ReservedKeypressCount
	While iCurrentCycle >= iMaxCycles && iMaxCycles
		iCurrentCycle = iCurrentCycle - iMaxCycles
	EndWhile
	If !iMaxCycles
		iCurrentCycle = 0
	EndIf
	;debug.messagebox("")
	;debug.trace("thinks this cycle is " + iCurrentCycle)
	Int iNextCycle = iCurrentCycle + 1
	;debug.trace("thinks next cycle is " + iNextCycle)
	JArray.setInt(objHotkeyAtCurrentCycleArray,CurrentIndex,iNextCycle)
	
	If MCMScript.fCycleTimeout
		RegisterForSingleUpdate(MCMScript.fCycleTimeout)
	EndIf
	
	objEquipsetData = JArray.getObj(objCycleEquipsetDataArray,iCurrentCycle)
	If JArray.getInt(objCycleUnequipAllPriorArray,iCurrentCycle) ;disabled
		player.UnequipAll()
		;utility.wait(1.0)
	EndIf
	Int iEquipmentArraySize = JValue.count(objEquipmentNamesArray)
	Int iThreadIndex = 0
	;debug.trace("iEquipmentArraySize is " + iEquipmentArraySize)
	While ThreadsProcessing ;iThreadIndex < iEquipmentArraySize && ThreadsProcessing
		;debug.trace("Serio_DEBUG " + iThreadIndex + " " + iEquipmentArraySize)
		If !Thread01.Queued() && iThreadIndex < iEquipmentArraySize
			Thread01.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1
		ElseIf !Thread02.Queued() && iThreadIndex < iEquipmentArraySize
			Thread02.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1
		ElseIf !Thread03.Queued() && iThreadIndex < iEquipmentArraySize
			Thread03.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1
;/ 		ElseIf !Thread04.Queued() && iThreadIndex < iEquipmentArraySize
			Thread04.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1
		ElseIf !Thread05.Queued() && iThreadIndex < iEquipmentArraySize
			Thread05.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1
		ElseIf !Thread06.Queued() && iThreadIndex < iEquipmentArraySize
			Thread06.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1
		ElseIf !Thread07.Queued() && iThreadIndex < iEquipmentArraySize
			Thread07.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1
		ElseIf !Thread08.Queued() && iThreadIndex < iEquipmentArraySize
			Thread08.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1
		ElseIf !Thread09.Queued() && iThreadIndex < iEquipmentArraySize
			Thread09.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1
		ElseIf !Thread10.Queued() && iThreadIndex < iEquipmentArraySize
			Thread10.StoreThreadVariables(iThreadIndex)
			iThreadIndex += 1 /;
		Else
			;debug.trace("ping")
			SendAsyncEvent()
			WaitForThreadQueue()
			;utility.wait(1.0)
			If iThreadIndex == iEquipmentArraySize
				;utility.wait(0.1*iEquipmentArraySize)
				ThreadsProcessing = false ;==== end new
				;utility.wait(1.0)
			EndIf
		EndIf
		;debug.trace("Serio_DEBUG " + iThreadIndex)
		;SendAsyncEvent()
		;WaitForThreadQueue()
	EndWhile
	;ThreadsProcessing = false
	;debug.trace("Hotkey finished processing")
	If ReservedIndex >= 0
		int x = ReservedIndex
		ReservedIndex = -1
		ReservedKeypressCount -= 1
		;debug.notification("reserve firing at index " + x)
		ExecuteHotkey(x)
		return
	EndIf
	ReservedKeypressCount = 0; Reset to 0 just in case
EndFunction

Event OnUpdate()
	ResetAllCycles()
EndEvent

Function ResetAllCycles()
	If MCMScript.bCycleResetNotification
		debug.notification("Cycles Reset")
	EndIf
	Int i
	Int UL = JValue.count(objHotkeyAtCurrentCycleArray)
	While i < UL
		JArray.setInt(objHotkeyAtCurrentCycleArray,i,0)
		i += 1
	EndWhile
EndFunction

Function SendAsyncEvent()
	int handle = ModEvent.Create("Serio_HK_RunAsyncEquip")
	If handle 
		ModEvent.Send(handle)
	else
		debug.trace("Mod Event Serio_HK_RunAsyncEquip could not be sent for unknown reason.")
	EndIf
EndFunction

Function WaitForThreadQueue()
	Bool waiting = True
	Int i
	while waiting
		if Thread01.Queued() || Thread02.Queued() || Thread03.Queued() || Thread04.Queued() \
		|| Thread05.Queued() || Thread06.Queued() || Thread07.Queued() || Thread08.Queued() \
		|| Thread09.Queued() || Thread10.Queued()
			i += 1
			Utility.wait(0.1)
			if i >= 100
				debug.trace(self + "Error: Unresponsive Threads. Aborting...")
				UnlockThreads()
				ThreadsProcessing = false
				return
			endif
		else
			;;debug.trace("SHK Threads have completed")
			waiting = false
		endif
	EndWhile
EndFunction

Function UnlockThreads()
	If !Thread01.ForceUnlock()
		;debug.trace("Thread 1 failed to unlock.")
	EndIf
	If !Thread02.ForceUnlock()
		;debug.trace("Thread 2 failed to unlock.")
	EndIf
	If !Thread03.ForceUnlock()
		;debug.trace("Thread 3 failed to unlock.")
	EndIf
	If !Thread04.ForceUnlock()
		;debug.trace("Thread 4 failed to unlock.")
	EndIf
	If !Thread05.ForceUnlock()
		;debug.trace("Thread 5 failed to unlock.")
	EndIf
	If !Thread06.ForceUnlock()
		;debug.trace("Thread 6 failed to unlock.")
	EndIf
	If !Thread07.ForceUnlock()
		;debug.trace("Thread 7 failed to unlock.")
	EndIf
	If !Thread08.ForceUnlock()
		;debug.trace("Thread 8 failed to unlock.")
	EndIf
	If !Thread09.ForceUnlock()
		;debug.trace("Thread 9 failed to unlock.")
	EndIf
	If !Thread10.ForceUnlock()
		;debug.trace("Thread 10 failed to unlock.")
	EndIf
EndFunction

;=================== SETTER FUNCTIONS =============================

Function AppendNamesFromHotkeysToNamesArray()
	int objHotkey
	Int i
	Int UL = JValue.count(objHotkeyData)
	JValue.clear(objHotkeyNamesArray)
	While i < UL
		objHotkey = JArray.getObj(objHotkeyData,i)
		String hkName = JMap.getStr(objHotkey,"HotkeyName")
		JArray.addStr(objHotkeyNamesArray,hkName)
		i += 1
	EndWhile
EndFunction

Function CreateNewHotkey()
	Int iCount = (JValue.count(objHotkeyNamesArray) + 1)
	objCycleData = JMap.Object()
	JArray.addStr(objHotkeyNamesArray,"Hotkey " + iCount)
	JArray.addInt(objHotkeyMappingArray,-1)
	JArray.addInt(objHotkeyModifierMappingArray,-1) ;-- NEW
	JArray.addObj(objHotkeyCycleDataArray,objCycleData)
	JArray.addInt(objHotkeyAtCurrentCycleArray,0)
	CreateNewCycleDataForHotkey(iCount - 1)
	;objTempData = JMap.Object()
EndFunction

Function CreateNewVanillaHotkey()
	Int iCount = (JValue.count(objHotkeyNamesArray) + 1)
	objCycleData = JMap.Object()
	JArray.addStr(objHotkeyNamesArray,"Hotkey " + iCount)
	JArray.addStr(objHotkeyMappingArray,"Hotkey" + iCount)
	JArray.addObj(objHotkeyCycleDataArray,objCycleData)
	JArray.addInt(objHotkeyAtCurrentCycleArray,0)
	CreateNewCycleDataForHotkey(iCount - 1)
	;objTempData = JMap.Object()
EndFunction

Function CreateNewCycleDataForHotkey(Int akIndex)
	objCycleData = JArray.getObj(objHotkeyCycleDataArray,akIndex)
	If !JValue.count(objCycleNameArray)
		objCycleNameArray = JArray.Object()
		objCycleEquipsetDataArray = JArray.Object()
		objCycleUnequipAllPriorArray = JArray.Object()
	EndIf
	objEquipsetData = JMap.Object()

	Int iCount = (JValue.count(objCycleNameArray) + 1)
	JArray.addObj(objCycleEquipsetDataArray,objEquipsetData);
	JArray.addStr(objCycleNameArray,"Cycle " + iCount)
	JArray.addInt(objCycleUnequipAllPriorArray,0)
	;JArray.addObj(objHotkeyCycleDataArray,objCycleData)
	;JArray.setObj(objHotkeyCycleDataArray,akIndex,JValue.deepCopy(objCycleData))
EndFunction

Function SendHotkeySetterMenuOpenEvent()
	int handle = ModEvent.Create("Serio_HK_HotkeySetterMenuOpen")
	If handle 
		ModEvent.Send(handle)
	else
		;debug.trace("Mod Event Serio_HK_HotkeySetterMenuOpen could not be sent for unknown reason.")
	EndIf
EndFunction

Bool bStoringFormsNow
Event OnHotkeySetterMenuOpen()
	If bStoringFormsNow
		return
	EndIf
	bStoringFormsNow = True
	
	objCurrentEquipmentCacheData = JMap.Object()
	objCurrentEquipmentCacheFormsArray = JArray.Object()
	objCurrentEquipmentCacheIDsArray = JArray.Object()
	objCurrentEquipmentCacheNamesArray = JArray.Object()
	objCurrentEquipmentCacheSlotsArray = JArray.Object()
	objCurrentEquipmentCacheTypesArray = JArray.Object()
	
	StoreEquippedItemsToCache()
	;StoreWornItemsToCache() ;--New. Disabling because it breaks.
	bStoringFormsNow = False
EndEvent

int tmpHotkeyIndex
Function OpenHotkeySelectionMenu()
	If (Player.GetRace() == VampireLord) || (Player.GetRace() == Werewolf)
		return
	EndIf
	
	SendHotkeySetterMenuOpenEvent()	
	;=== Select Hotkey
	String[] strNamesMenu = new string[128]
	strNamesMenu[0] = "(Cancel)"
	int i
	Int UL = JValue.count(objHotkeyNamesArray)
	While i < UL
		strNamesMenu[(i+1)] = JArray.getStr(objHotkeyNamesArray,i)
		i += 1
	EndWhile
	;UILib_1 UILib = (Self as Form) as UILib_1
	int iSelection = UILib.ShowList("Select Hotkey", strNamesMenu,1,0)
	If !iSelection
		return
	EndIf
	tmpHotkeyIndex = iSelection - 1
	OpenCycleSelectionMenu()
EndFunction

int tmpCycleIndex
Function OpenCycleSelectionMenu()
	;=== Select Cycle
	objCycleData = JArray.getObj(objHotkeyCycleDataArray,tmpHotkeyIndex)
	String strHotkeyName = JArray.getStr(objHotkeyNamesArray,tmpHotkeyIndex)
	String[] strCycleNameMenu = new string[128]
	strCycleNameMenu[0] = "(Cancel)"
	strCycleNameMenu[1] = "(Back)"
	strCycleNameMenu[2] = "(Reset All Cycles)"
	int i = 0
	int UL = JValue.count(objCycleNameArray)
	int iCount = UL - 1
	While UL
		UL -= 1
		String strCycleName
		If UL == iCount ;If this is the last cycle.
			strCycleName = JArray.getStr(objCycleNameArray,UL)
		Else
			strCycleName = JArray.getStr(objCycleNameArray,UL) + " (Reset/Delete)"
		EndIf
		strCycleNameMenu[(i+3)] = strCycleName
		i += 1
	EndWhile
	;UILib_1 UILib = (Self as Form) as UILib_1
	int iSelection = UILib.ShowList(strHotkeyName + ": Select Cycle", strCycleNameMenu,3,1)
	
	If !iSelection
		return
	ElseIf iSelection == 1
		OpenHotkeySelectionMenu()
		return
	ElseIf iSelection == 2
		DeleteAllCycles()
		OpenCycleSelectionMenu()
		return
	ElseIf iSelection == 3
		tmpCycleIndex = iCount - (iSelection - 3)
		OpenEquipmentSelectionMenu()
		return
	Else
		tmpCycleIndex = iCount - (iSelection - 3)
		OpenCycleOptionsMenu()
	EndIf
EndFunction

Function OpenCycleOptionsMenu()
	;=== Select Cycle Options
	objEquipsetData = JArray.getObj(objCycleEquipsetDataArray,tmpCycleIndex)
	String strCycleName = JArray.getStr(objCycleNameArray,tmpCycleIndex)
	String[] strCycleMenu = new String[10]
	strCycleMenu[0] = "(Cancel)"
	strCycleMenu[1] = "(Back)"
	strCycleMenu[2] = "Reset"
	strCycleMenu[3] = "Delete"
	int iSelection = UILib.ShowList(strCycleName + "Options", strCycleMenu,3,3)
	If !iSelection
		return
	ElseIf iSelection == 1
		OpenCycleSelectionMenu()
	ElseIf iSelection == 2
		ResetEquipmentDataArrays()
		OpenEquipmentSelectionMenu(false)
	ElseIf iSelection == 3
		DeleteCycle(tmpCycleIndex)
		OpenCycleSelectionMenu()
	EndIf
EndFunction

int tmpSpecificEquipmentIndex ;not sure if this will be needed
Bool UnequipLeft
Bool UnequipRight
Function OpenEquipmentSelectionMenu(bool bCreateNewCycle = True)
	int x
	While bStoringFormsNow
		utility.wait(0.1)
		x += 1
		if x >= 50
			;debug.trace("Error: Hotkey equipment selection menu froze retrieving worn items.")
			bStoringFormsNow = false
			return
		EndIf
	EndWhile
	
	objEquipsetData = JArray.getObj(objCycleEquipsetDataArray,tmpCycleIndex)
	String strCycleName = JArray.getStr(objCycleNameArray,tmpCycleIndex)
	String[] strEquipsetMenu = new String[60]
	strEquipsetMenu[0] = "(Accept)"
	strEquipsetMenu[1] = "(Select All)"
	;strEquipsetMenu[2] = "(Unequip All Prior Equipment: Off)" ;--- New
	
	UnequipLeft = false
	UnequipRight = false
	
	int OptionSize = 2 ;--New. Changed from 3 after disabling unequip.
;	If JArray.FindInt(objCurrentEquipmentCacheSlotsArray,2) >= 0
;		strEquipsetMenu[OptionSize] = "(Unequip Left)"
;		OptionSize += 1
;	EndIf
;	If JArray.FindInt(objCurrentEquipmentCacheSlotsArray,1) >= 0
;		strEquipsetMenu[OptionSize] = "(Unequip Right)"
;		OptionSize += 1
;	EndIf
	
	int i
	int UL = JValue.count(objCurrentEquipmentCacheNamesArray)
	While i < UL
		strEquipsetMenu[(i+OptionSize)] = JArray.getStr(objCurrentEquipmentCacheNamesArray,i)
		i += 1
	EndWhile
	
	int iPreCount = (i+OptionSize)
	If JArray.FindInt(objCurrentEquipmentCacheSlotsArray,2) >= 0
		strEquipsetMenu[iPreCount] = "(Unequip Left)"
		iPreCount += 1
	EndIf
	If JArray.FindInt(objCurrentEquipmentCacheSlotsArray,1) >= 0
		strEquipsetMenu[iPreCount] = "(Unequip Right)"
		iPreCount += 1
	EndIf
	
		;We are not storing the names, forms, etc. right away, but instead storing the indicies and then storing after the selections are "accepted".
	Int iSelection = -1 ; Set to -1 so the while condition picks it up.
	int ObjIndexToStoreArray = JValue.retain(JArray.Object())
	i = 0
	While iSelection && i < 100 ; i is contingency for impossible event in which the loop continues.
		iSelection = UILib.ShowList(strCycleName + ": Store Equipment", strEquipsetMenu,1,0)
		int y = iSelection - OptionSize ; y is the selection index minus the first options
		;debug.notification(JArray.FindInt(ObjIndexToStoreArray,y))
		
		If iSelection == 1
			int z = OptionSize
			While strEquipSetMenu[z]
				y = z - OptionSize
				Bool bUnequip = false
				
				If (strEquipSetMenu[z] == "(Unequip Left)") || (strEquipSetMenu[z] == "(Unequip Right)")
					bUnequip = true
				EndIf
				
				If JArray.FindInt(ObjIndexToStoreArray,y) == -1 && !bUnequip
					JArray.addInt(ObjIndexToStoreArray,y)
					strEquipsetMenu[z] = JArray.getStr(objCurrentEquipmentCacheNamesArray,y) + " (Stored)"
				ElseIf !bUnequip
					;/ debug.trace("Serio_Debug: Processing on " + strEquipSetMenu[z])
					debug.trace("Serio_Debug: JArray.FindInt(objCurrentEquipmentCacheSlotsArray,2) is " + JArray.FindInt(objCurrentEquipmentCacheSlotsArray,2))
					debug.trace("Serio_Debug: y) is " + y)
					debug.trace("Serio_Debug: UnequipLeft is " + UnequipLeft)
					debug.trace("Serio_Debug: UnequipRight is " + UnequipRight) /;
					If UnequipLeft && JArray.FindInt(objCurrentEquipmentCacheSlotsArray,2) == y ;JArray.FindInt(ObjIndexToStoreArray,y)
						UnequipLeft = False
						strEquipsetMenu[z] = JArray.getStr(objCurrentEquipmentCacheNamesArray,y) + " (Stored)"
					ElseIf UnequipRight && JArray.FindInt(objCurrentEquipmentCacheSlotsArray,1) == y ;JArray.FindInt(ObjIndexToStoreArray,y)
						UnequipRight = False
						strEquipsetMenu[z] = JArray.getStr(objCurrentEquipmentCacheNamesArray,y) + " (Stored)"
					EndIf
				EndIf
				z += 1
			Endwhile
		;ElseIf iSelection == 2 ;--- New
		;	If !JArray.getInt(objCycleUnequipAllPriorArray,tmpCycleIndex)
		;		JArray.setInt(objCycleUnequipAllPriorArray,tmpCycleIndex,1)
		;		strEquipsetMenu[iSelection] = "(Unequip All Prior Equipment: On)"
		;	Else
		;		JArray.setInt(objCycleUnequipAllPriorArray,tmpCycleIndex,0)
		;		strEquipsetMenu[iSelection] = "(Unequip All Prior Equipment: Off)"
		;	EndIf
		ElseIf strEquipsetMenu[iSelection] == "(Unequip Left)"
			UnequipLeft = true
			y = JArray.FindInt(objCurrentEquipmentCacheSlotsArray,2)
			If JArray.FindInt(ObjIndexToStoreArray,y) == -1
				JArray.addInt(ObjIndexToStoreArray,y)
			EndIf
			strEquipsetMenu[y+OptionSize] = "Left: (Unequip)"
		ElseIf strEquipsetMenu[iSelection] == "(Unequip Right)"
			UnequipRight = true
			y = JArray.FindInt(objCurrentEquipmentCacheSlotsArray,1)
			If JArray.FindInt(ObjIndexToStoreArray,y) == -1
				JArray.addInt(ObjIndexToStoreArray,y)
			EndIf
			strEquipsetMenu[y+OptionSize] = "Right: (Unequip)"
		ElseIf iSelection
			If JArray.FindInt(ObjIndexToStoreArray,y) == -1
				JArray.addInt(ObjIndexToStoreArray,y)
				strEquipsetMenu[iSelection] = JArray.getStr(objCurrentEquipmentCacheNamesArray,y) + " (Stored)"
			Else
				If UnequipLeft && JArray.FindInt(objCurrentEquipmentCacheSlotsArray,2) == JArray.FindInt(ObjIndexToStoreArray,y)
					UnequipLeft = False
					strEquipsetMenu[iSelection] = JArray.getStr(objCurrentEquipmentCacheNamesArray,y) + " (Stored)"
				ElseIf UnequipRight && JArray.FindInt(objCurrentEquipmentCacheSlotsArray,1) == JArray.FindInt(ObjIndexToStoreArray,y)
					UnequipRight = False
					strEquipsetMenu[iSelection] = JArray.getStr(objCurrentEquipmentCacheNamesArray,y) + " (Stored)"
				
				Else
					JArray.eraseIndex(ObjIndexToStoreArray,JArray.FindInt(ObjIndexToStoreArray,y))
					strEquipsetMenu[iSelection] = JArray.getStr(objCurrentEquipmentCacheNamesArray,y)				
				EndIf
			EndIf
		EndIf
		i += 1
	EndWhile
	
	i = 0
	UL = JValue.count(ObjIndexToStoreArray)
	If UL ; If player selected something to store
		objEquipsetData = JArray.getObj(objCycleEquipsetDataArray,tmpCycleIndex)
		ResetEquipmentDataArrays()
		While i < UL
			Int y = JArray.getInt(ObjIndexToStoreArray,i)
				;debug.trace("storing index " + y + " from objIndexToStoreArray")
				;debug.trace("JArray.FindInt(objCurrentEquipmentCacheSlotsArray,1) is " + JArray.FindInt(objCurrentEquipmentCacheSlotsArray,1))
			If UnequipLeft && JArray.FindInt(objCurrentEquipmentCacheSlotsArray,2) == y
				;debug.trace("flagging left item to unequip")
				JArray.addStr(objEquipmentNamesArray,"Unequip Left")
			ElseIf UnequipRight && JArray.FindInt(objCurrentEquipmentCacheSlotsArray,1) == y
				;debug.trace("flagging right item to unequip")
				JArray.addStr(objEquipmentNamesArray,"Unequip Right")
			Else
				JArray.addStr(objEquipmentNamesArray,JArray.getStr(objCurrentEquipmentCacheNamesArray,y))
			EndIf
			
			JArray.addForm(objEquipmentFormsArray,JArray.getForm(objCurrentEquipmentCacheFormsArray,y))
			JArray.addInt(objEquipmentIDsArray,JArray.getInt(objCurrentEquipmentCacheIDsArray,y))
			JArray.addInt(objEquipmentTypesArray,JArray.getInt(objCurrentEquipmentCacheTypesArray,y))
			JArray.addInt(objEquipmentSlotsArray,JArray.getInt(objCurrentEquipmentCacheSlotsArray,y))
			i += 1
		Endwhile
		If bCreateNewCycle
			CreateNewCycleDataForHotkey(tmpHotkeyIndex)
		EndIf
	EndIf
	;debug.notification("done")
	JValue.release(ObjIndexToStoreArray)
EndFunction

Function DeleteCycle(int akIndex)
	;objEquipsetData = JArray.getObj(objCycleEquipsetDataArray,akIndex)
	Int UL = JValue.count(objCycleNameArray)
	If !akIndex && (UL == 1)
		ResetEquipmentDataArrays()
		Return
	EndIf
	JArray.EraseIndex(objCycleEquipsetDataArray,akIndex)
	JArray.EraseIndex(objCycleNameArray,akIndex)
	JArray.EraseIndex(objCycleUnequipAllPriorArray,akIndex)
	;=== Append Cycle Names
	Int i
	While i < UL
		JArray.setStr(objCycleNameArray,i,"Cycle " + (i + 1))
		i += 1
	EndWhile
EndFunction

Function DeleteAllCycles()
	Int i
	Int UL = JValue.count(objCycleNameArray)
	While i < UL
		DeleteCycle(0)
		i += 1
	Endwhile
EndFunction

Function ResetEquipmentDataArrays()
	objEquipmentFormsArray = JArray.Object()
	objEquipmentNamesArray = JArray.Object()
	objEquipmentIDsArray = JArray.Object()
	objEquipmentTypesArray = JArray.Object()
	objEquipmentSlotsArray = JArray.Object()
EndFunction

Function StoreEquippedItemsToCache()
	;objEquipsetData = JArray.getObj(objCycleEquipsetDataArray,akIndex)
	Form kForm
	String kName
	Int kID
	Int kType
	Int kSlot
	Int kEquipItemSlot
	
	Int i
	Int UL = JArray.count(objEquipItemSlotReferenceArray)
	While i < UL
		kSlot = JArray.getInt(objEquipItemSlotReferenceArray, i)
		kForm = Player.GetEquippedObject(kSlot)
		If kForm
			kType = kForm.GetType()
			Bool bSkip = false
			
			If kSlot == 0 && kType == kWeapon && IsWeaponTwoHanded(kForm)
				bSkip = True
			ElseIf kSlot == 0
				kName = ("Left: " + kForm.GetName())
				kEquipItemSlot = 2
			ElseIf kSlot == 1 ;Right
				If kType == kWeapon && IsWeaponTwoHanded(kForm)
					kName = ("2H: " + kForm.GetName())
				Else
					kName = ("Right: " + kForm.GetName())
				EndIf
				kEquipItemSlot = 1
			ElseIf kSlot == 2 && kType == 119
				kName = ("Shout: " + kForm.GetName())
				kEquipItemSlot = 0
			ElseIf kSlot == 2 && kType == 22
				kName = ("Power: " + kForm.GetName())
				kEquipItemSlot = 0
			ElseIf kSlot == 2 && kForm == None ; New
				bSkip = True
			Else ; This should theoretically not happen, but just in case a name must still be set for the array data to align.
				kName = kForm.GetName()
			EndIf
			If kType != kArmor
				kID = Player.GetEquippedItemID(kSlot)
			Else ; This should be the shield
				kID = Player.GetWornItemID(kSlotMask39)
			EndIf
			
			If !bSkip
				JArray.addForm(objCurrentEquipmentCacheFormsArray,kForm)
				JArray.addStr(objCurrentEquipmentCacheNamesArray,kName)
				JArray.addInt(objCurrentEquipmentCacheIDsArray,kID)
				JArray.addInt(objCurrentEquipmentCacheTypesArray,kType)
				JArray.addInt(objCurrentEquipmentCacheSlotsArray,kEquipItemSlot)
			EndIf
			
		EndIf
		i += 1
	EndWhile
EndFunction

Bool Function IsWeaponTwoHanded(Form akForm)
	If (akForm as weapon).GetWeaponType() == 5
		;debug.notification("greatsword")
		return true
	ElseIf (akForm as weapon).GetWeaponType() == 6
		;debug.notification("battleaxe/warhammer")
		return true
	ElseIf (akForm as weapon).GetWeaponType() == 7
		;debug.notification("bow")
		return true
	ElseIf (akForm as weapon).GetWeaponType() == 9
		;debug.notification("crossbow")
		return true
	Else
		return False
	EndIf
EndFunction

Function StoreWornItemsToCache()
	;objEquipsetData = JArray.getObj(objCycleEquipsetDataArray,akIndex)
	Form kForm
	String kName
	Int kID
	Int kType
	Int kSlotMask
	
	Int i
	Int UL = JArray.count(objWornItemSlotMaskReferenceArray)
	While i < UL
		kSlotMask = JArray.getInt(objWornItemSlotMaskReferenceArray, i)
		kForm = Player.GetWornForm(kSlotMask)
		If kForm
			kType = kForm.GetType()
			kName = kForm.GetName()
			kID = Player.GetWornItemID(kSlotMask)
			
			JArray.addForm(objCurrentEquipmentCacheFormsArray,kForm)
			JArray.addStr(objCurrentEquipmentCacheNamesArray,kName)
			JArray.addInt(objCurrentEquipmentCacheIDsArray,kID)
			JArray.addInt(objCurrentEquipmentCacheTypesArray,kType)
			JArray.addInt(objCurrentEquipmentCacheSlotsArray,0); Worn items don't get equipped to slots. 
		EndIf
		i += 1
	EndWhile
EndFunction

Function LoadEquipItemArray()
	objEquipItemSlotReferenceArray = JArray.Object()
	
	JArray.addInt(objEquipItemSlotReferenceArray,kSlotLeftHand)
	JArray.addInt(objEquipItemSlotReferenceArray,kSlotRightHand)
	JArray.addInt(objEquipItemSlotReferenceArray,kSlotShoutPower)
EndFunction

Function LoadWornItemArray()
	objWornItemSlotMaskReferenceArray = JArray.Object()
	
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask30)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask31)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask32)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask33)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask34)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask35)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask36)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask37)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask38)
	;Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask39) ; Shield
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask40)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask41)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask42)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask43)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask44)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask45)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask46)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask47)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask48)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask49)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask50)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask51)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask52)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask53)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask54)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask55)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask56)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask57)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask58)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask59)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask60)
	Jarray.addInt(objWornItemSlotMaskReferenceArray,	kSlotMask61)
EndFunction

;=================== SYRIM VARIABLES ===========================

;------------- Item Types --------------------
Int Property kANIO = 83 AutoReadOnly
Int Property kARMA = 102 AutoReadOnly
Int Property kAcousticSpace = 16 AutoReadOnly
Int Property kAction = 6 AutoReadOnly
Int Property kActivator = 24 AutoReadOnly
Int Property kActorValueInfo = 95 AutoReadOnly
Int Property kAddonNode = 94 AutoReadOnly
Int Property kAmmo = 42 AutoReadOnly
Int Property kApparatus = 33 AutoReadOnly
Int Property kArmor = 26 AutoReadOnly
Int Property kArrowProjectile = 64 AutoReadOnly
Int Property kArt = 125 AutoReadOnly
Int Property kAssociationType = 123 AutoReadOnly
Int Property kBarrierProjectile = 69 AutoReadOnly
Int Property kBeamProjectile = 66 AutoReadOnly
Int Property kBodyPartData = 93 AutoReadOnly
Int Property kBook = 27 AutoReadOnly
Int Property kCameraPath = 97 AutoReadOnly
Int Property kCameraShot = 96 AutoReadOnly
Int Property kCell = 60 AutoReadOnly
Int Property kCharacter = 62 AutoReadOnly
Int Property kClass = 10 AutoReadOnly
Int Property kClimate = 55 AutoReadOnly
Int Property kCollisionLayer = 132 AutoReadOnly
Int Property kColorForm = 133 AutoReadOnly
Int Property kCombatStyle = 80 AutoReadOnly
Int Property kConeProjectile = 68 AutoReadOnly
Int Property kConstructibleObject = 49 AutoReadOnly
Int Property kContainer = 28 AutoReadOnly
Int Property kDLVW = 117 AutoReadOnly
Int Property kDebris = 88 AutoReadOnly
Int Property kDefaultObject = 107 AutoReadOnly
Int Property kDialogueBranch = 115 AutoReadOnly
Int Property kDoor = 29 AutoReadOnly
Int Property kDualCastData = 129 AutoReadOnly
Int Property kEffectSetting = 18 AutoReadOnly
Int Property kEffectShader = 85 AutoReadOnly
Int Property kEnchantment = 21 AutoReadOnly
Int Property kEncounterZone = 103 AutoReadOnly
Int Property kEquipSlot = 120 AutoReadOnly
Int Property kExplosion = 87 AutoReadOnly
Int Property kEyes = 13 AutoReadOnly
Int Property kFaction = 11 AutoReadOnly
Int Property kFlameProjectile = 67 AutoReadOnly
Int Property kFlora = 39 AutoReadOnly
Int Property kFootstep = 110 AutoReadOnly
Int Property kFootstepSet = 111 AutoReadOnly
Int Property kFurniture = 40 AutoReadOnly
Int Property kGMST = 3 AutoReadOnly
Int Property kGlobal = 9 AutoReadOnly
Int Property kGrass = 37 AutoReadOnly
Int Property kGrenadeProjectile = 65 AutoReadOnly
Int Property kGroup = 2 AutoReadOnly
Int Property kHazard = 51 AutoReadOnly
Int Property kHeadPart = 12 AutoReadOnly
Int Property kIdle = 78 AutoReadOnly
Int Property kIdleMarker = 47 AutoReadOnly
Int Property kImageSpace = 89 AutoReadOnly
Int Property kImageSpaceModifier = 90 AutoReadOnly
Int Property kImpactData = 100 AutoReadOnly
Int Property kImpactDataSet = 101 AutoReadOnly
Int Property kIngredient = 30 AutoReadOnly
Int Property kKey = 45 AutoReadOnly
Int Property kKeyword = 4 AutoReadOnly
Int Property kLand = 72 AutoReadOnly
Int Property kLandTexture = 20 AutoReadOnly
Int Property kLeveledCharacter = 44 AutoReadOnly
Int Property kLeveledItem = 53 AutoReadOnly
Int Property kLeveledSpell = 82 AutoReadOnly
Int Property kLight = 31 AutoReadOnly
Int Property kLightingTemplate = 108 AutoReadOnly
Int Property kList = 91 AutoReadOnly
Int Property kLoadScreen = 81 AutoReadOnly
Int Property kLocation = 104 AutoReadOnly
Int Property kLocationRef = 5 AutoReadOnly
Int Property kMaterial = 126 AutoReadOnly
Int Property kMaterialType = 99 AutoReadOnly
Int Property kMenuIcon = 8 AutoReadOnly
Int Property kMessage = 105 AutoReadOnly
Int Property kMisc = 32 AutoReadOnly
Int Property kMissileProjectile = 63 AutoReadOnly
Int Property kMovableStatic = 36 AutoReadOnly
Int Property kMovementType = 127 AutoReadOnly
Int Property kMusicTrack = 116 AutoReadOnly
Int Property kMusicType = 109 AutoReadOnly
Int Property kNAVI = 59 AutoReadOnly
Int Property kNPC = 43 AutoReadOnly
Int Property kNavMesh = 73 AutoReadOnly
Int Property kNone = 0 AutoReadOnly
Int Property kNote = 48 AutoReadOnly
Int Property kOutfit = 124 AutoReadOnly
Int Property kPHZD = 70 AutoReadOnly
Int Property kPackage = 79 AutoReadOnly
Int Property kPerk = 92 AutoReadOnly
Int Property kPotion = 46 AutoReadOnly
Int Property kProjectile = 50 AutoReadOnly
Int Property kQuest = 77 AutoReadOnly
Int Property kRace = 14 AutoReadOnly
Int Property kRagdoll = 106 AutoReadOnly
Int Property kReference = 61 AutoReadOnly
Int Property kReferenceEffect = 57 AutoReadOnly
Int Property kRegion = 58 AutoReadOnly
Int Property kRelationship = 121 AutoReadOnly
Int Property kReverbParam = 134 AutoReadOnly
Int Property kScene = 122 AutoReadOnly
Int Property kScript = 19 AutoReadOnly
Int Property kScrollItem = 23 AutoReadOnly
Int Property kShaderParticleGeometryData = 56 AutoReadOnly
Int Property kShout = 119 AutoReadOnly
Int Property kSkill = 17 AutoReadOnly
Int Property kSoulGem = 52 AutoReadOnly
Int Property kSound = 15 AutoReadOnly
Int Property kSoundCategory = 130 AutoReadOnly
Int Property kSoundDescriptor = 128 AutoReadOnly
Int Property kSoundOutput = 131 AutoReadOnly
Int Property kSpell = 22 AutoReadOnly
Int Property kStatic = 34 AutoReadOnly
Int Property kStaticCollection = 35 AutoReadOnly
Int Property kStoryBranchNode = 112 AutoReadOnly
Int Property kStoryEventNode = 114 AutoReadOnly
Int Property kStoryQuestNode = 113 AutoReadOnly
Int Property kTES4 = 1 AutoReadOnly
Int Property kTLOD = 74 AutoReadOnly
Int Property kTOFT = 86 AutoReadOnly
Int Property kTalkingActivator = 25 AutoReadOnly
Int Property kTextureSet = 7 AutoReadOnly
Int Property kTopic = 75 AutoReadOnly
Int Property kTopicInfo = 76 AutoReadOnly
Int Property kTree = 38 AutoReadOnly
Int Property kVoiceType = 98 AutoReadOnly
Int Property kWater = 84 AutoReadOnly
Int Property kWeapon = 41 AutoReadOnly
Int Property kWeather = 54 AutoReadOnly
Int Property kWordOfPower = 118 AutoReadOnly
Int Property kWorldSpace = 71 AutoReadOnly

;----------- EquipItem Slots -------------------
int Property kSlotLeftHand = 0 AutoReadOnly
int Property kSlotRightHand = 1 AutoReadOnly
int Property kSlotShoutPower = 2 AutoReadOnly

;----------- Armor Slot Masks ------------------
int Property kSlotMask30 = 0x00000001 AutoReadOnly ; HEAD
int Property kSlotMask31 = 0x00000002 AutoReadOnly ; Hair
int Property kSlotMask32 = 0x00000004 AutoReadOnly ; BODY
int Property kSlotMask33 = 0x00000008 AutoReadOnly ; Hands
int Property kSlotMask34 = 0x00000010 AutoReadOnly ; Forearms
int Property kSlotMask35 = 0x00000020 AutoReadOnly ; Amulet
int Property kSlotMask36 = 0x00000040 AutoReadOnly ; Ring
int Property kSlotMask37 = 0x00000080 AutoReadOnly ; Feet
int Property kSlotMask38 = 0x00000100 AutoReadOnly ; Calves
int Property kSlotMask39 = 0x00000200 AutoReadOnly ; SHIELD
int Property kSlotMask40 = 0x00000400 AutoReadOnly ; TAIL
int Property kSlotMask41 = 0x00000800 AutoReadOnly ; LongHair
int Property kSlotMask42 = 0x00001000 AutoReadOnly ; Circlet
int Property kSlotMask43 = 0x00002000 AutoReadOnly ; Ears
int Property kSlotMask44 = 0x00004000 AutoReadOnly ; Unnamed
int Property kSlotMask45 = 0x00008000 AutoReadOnly ; Unnamed
int Property kSlotMask46 = 0x00010000 AutoReadOnly ; Unnamed
int Property kSlotMask47 = 0x00020000 AutoReadOnly ; Unnamed
int Property kSlotMask48 = 0x00040000 AutoReadOnly ; Unnamed
int Property kSlotMask49 = 0x00080000 AutoReadOnly ; Unnamed
int Property kSlotMask50 = 0x00100000 AutoReadOnly ; DecapitateHead
int Property kSlotMask51 = 0x00200000 AutoReadOnly ; Decapitate
int Property kSlotMask52 = 0x00400000 AutoReadOnly ; Unnamed
int Property kSlotMask53 = 0x00800000 AutoReadOnly ; Unnamed
int Property kSlotMask54 = 0x01000000 AutoReadOnly ; Unnamed
int Property kSlotMask55 = 0x02000000 AutoReadOnly ; Unnamed
int Property kSlotMask56 = 0x04000000 AutoReadOnly ; Unnamed
int Property kSlotMask57 = 0x08000000 AutoReadOnly ; Unnamed
int Property kSlotMask58 = 0x10000000 AutoReadOnly ; Unnamed
int Property kSlotMask59 = 0x20000000 AutoReadOnly ; Unnamed
int Property kSlotMask60 = 0x40000000 AutoReadOnly ; Unnamed
int Property kSlotMask61 = 0x80000000 AutoReadOnly ; FX01
