Scriptname Serio_HK_MCMScript extends SKI_ConfigBase  

Serio_HK_HotkeyMainScript Property MainScript Auto

Int Property KEY_LCTRL = 29 AutoReadOnly Hidden
Int Property KEY_LALT = 56 AutoReadOnly Hidden

Bool Property bDoLCtrlForSetter = false Auto Hidden
Bool Property bDoLAltForSetter = false Auto Hidden

Bool Property bUseVanillaHotkeys = false Auto Hidden
Int Property HotkeySetterKey = -1 Auto Hidden
float Property fCycleTimeout = 2.5 Auto Hidden

Int Property tmpHotkeyArrayIndex = 0 Auto Hidden
Int Property tmpMappedKey = 0 Auto Hidden
Int Property tmpModifierKey = 0 Auto Hidden ;-- NEW
String Property tmpHotkeyName = "" Auto Hidden
Bool Property bExitOnReset = False Auto Hidden ;-- NEW
Bool Property bModEnabled = True Auto Hidden
Bool Property bCycleResetNotification = True Auto Hidden
;======= MAIN EVENTS & FUNCITONS ===============================================================

Event OnConfigInit()
;--- Pages are already a property in SKI_ConfigBase
	Pages = new string[3]
	Pages[0] = "Settings"
	Pages[1] = "Hotkeys"
	Pages[2] = "Profile"

	debug.notification("Serio's Hotkeys MCM Initialized")
EndEvent

Event OnConfigOpen()
	Pages = new string[3]
	Pages[0] = "Settings"
	Pages[1] = "Hotkeys"
	Pages[2] = "Profile"
	;debug.notification("Config opened")
	tmpHotkeyArrayIndex = 0
	bExitOnReset = False
EndEvent

Event OnPageReset(String page)
	If bExitOnReset
		return
	EndIf
	
	If (page == "Settings") && !bModEnabled
		AddTextOptionST("ReinstallMod","","Reinstall")
		AddHeaderOption("")
	ElseIf (page == "Settings") && bModEnabled
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Hotkey Setter")
		AddKeyMapOptionST("HotkeySetterKey","Setter Hotkey", HotkeySetterKey, OPTION_FLAG_WITH_UNMAP)
		AddToggleOptionST("bDoLCtrlForSetter","   + Ctrl",bDoLCtrlForSetter)
		AddToggleOptionST("bDoLAltForSetter","   + Alt",bDoLAltForSetter)
		AddHeaderOption("")
		SetCursorPosition(1)
		AddHeaderOption("Gamepad Support")
		AddToggleOptionST("bUseVanillaHotkeys","Use Vanilla Hotkeys",bUseVanillaHotkeys)
		AddHeaderOption("")
		AddSliderOptionST("CycleTimeout","Cycle Timeout",fCycleTimeout,"{2} seconds")
		AddToggleOptionST("bCycleResetNotification","Cycle Reset Notification",bCycleResetNotification)
		AddHeaderOption("")
		AddTextOptionST("UninstallMod","","Uninstall")
		AddHeaderOption("")
	ElseIf (page == "Hotkeys") && bModEnabled
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddMenuOptionST("HotkeyMenuOption","Select Hotkey","")
		If !bUseVanillaHotkeys
			AddTextOptionST("AddMoreHotkeys","Add 10 More Hotkeys?","Yes")
		EndIf
		AddHeaderOption("")
		FillHotkeyOptions()
		SetCursorPosition(1)
		FillCycleData()
	ElseIf (page == "Profile") && bModEnabled
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddTextOptionST("SaveProfile1","Profile 1","Save")
		AddTextOptionST("SaveProfile2","Profile 2","Save")
		AddTextOptionST("SaveProfile3","Profile 3","Save")
		AddTextOptionST("SaveProfile4","Profile 4","Save")
		AddTextOptionST("SaveProfile5","Profile 5","Save")
		AddHeaderOption("")
		AddTextOptionST("ResetData","Reset Data?","Yes")
		SetCursorPosition(1)
		AddTextOptionST("LoadProfile1","Profile 1","Load")
		AddTextOptionST("LoadProfile2","Profile 2","Load")
		AddTextOptionST("LoadProfile3","Profile 3","Load")
		AddTextOptionST("LoadProfile4","Profile 4","Load")
		AddTextOptionST("LoadProfile5","Profile 5","Load")
		AddHeaderOption("")
	EndIf
EndEvent

Function FillHotkeyOptions()
	tmpHotkeyName = JArray.getStr(MainScript.objHotkeyNamesArray,tmpHotkeyArrayIndex)
	
	If !bUseVanillaHotkeys
		tmpMappedKey = JArray.getInt(MainScript.objHotkeyMappingArray,tmpHotkeyArrayIndex)
		tmpModifierKey = JArray.getInt(MainScript.objHotkeyModifierMappingArray,tmpHotkeyArrayIndex) ;--NEW
		AddKeyMapOptionST("HotkeyMapChange",tmpHotkeyName, tmpMappedKey, OPTION_FLAG_WITH_UNMAP)
		AddKeyMapOptionST("HotkeyModifierMapChange","   +Key:", tmpModifierKey, OPTION_FLAG_WITH_UNMAP) ;-- NEW
	Else
		string strMappedKey = JArray.getStr(MainScript.objHotkeyMappingArray,tmpHotkeyArrayIndex)
		AddMenuOptionST("VanillaHotkeyMapChange",tmpHotkeyName, strMappedKey)
	EndIf
	AddInputOptionST("HotkeyChangeName","Rename Hotkey","")
	AddHeaderOption("")
EndFunction

Function FillCycleData()
	MainScript.objCycleData = JArray.getObj(MainScript.objHotkeyCycleDataArray,tmpHotkeyArrayIndex)
	int i
	int UL = JValue.count(MainScript.objCycleNameArray)
	While i < UL
		AddHeaderOption(JArray.getStr(MainScript.objCycleNameArray,i))
		MainScript.objEquipsetData = JArray.getObj(MainScript.objCycleEquipsetDataArray,i)
		int x = 0
		int xUL = JValue.count(MainScript.objEquipmentNamesArray)
		debug.trace("xUL is " + xUL + " and x is " + x)
		While x < xUL
			AddTextOption("",JArray.getStr(MainScript.objEquipmentNamesArray,x),OPTION_FLAG_DISABLED)
			x += 1
		EndWhile
		i += 1
	EndWhile
EndFunction

Event OnKeyDown(int keyCode)
	Bool MenuMode = Utility.IsInMenuMode()
	
	If MenuMode && !UI.IsMenuOpen("InventoryMenu") && !UI.IsMenuOpen("MagicMenu")
		Return
	EndIf
	
	If (keyCode == HotkeySetterKey) && (bDoLCtrlForSetter == Input.IsKeyPressed(KEY_LCTRL)) \
	&& (bDoLAltForSetter == Input.IsKeyPressed(KEY_LALT))
		MainScript.OpenHotkeySelectionMenu()
		;debug.notification("setter key pressed")
		return
	EndIf
	
	int aiSearchIndex = 0
	tmpHotkeyArrayIndex = 0
	Int UL = JValue.Count(MainScript.objHotkeyMappingArray)
	Int pressedModifierKey = -1
	Int pressedHotkeyArrayIndex = -1
	Int noModifierKeyIndex = -1
	Int pressedMappedKey = -1
	While tmpHotkeyArrayIndex >= 0 && !MenuMode && aiSearchIndex < UL
		tmpHotkeyArrayIndex = JArray.findInt(MainScript.objHotkeyMappingArray,keyCode, aiSearchIndex)
		tmpMappedKey = JArray.getInt(MainScript.objHotkeyMappingArray,tmpHotkeyArrayIndex)
		tmpModifierKey = JArray.getInt(MainScript.objHotkeyModifierMappingArray,tmpHotkeyArrayIndex) ;-- NEW

		If tmpHotkeyArrayIndex >=0
			pressedMappedKey = tmpMappedKey
		EndIf
		
		If tmpModifierKey != -1 && IsModifierKeyPressed(tmpModifierKey)
			pressedModifierKey = tmpModifierKey
			pressedHotkeyArrayIndex = tmpHotkeyArrayIndex
		ElseIf tmpHotkeyArrayIndex >= 0 && tmpModifierKey == -1
			noModifierKeyIndex = tmpHotkeyArrayIndex
		EndIf
		
		aiSearchIndex = tmpHotkeyArrayIndex + 1
	endwhile
	If pressedModifierKey < 0
		pressedHotkeyArrayIndex = noModifierKeyIndex
		pressedModifierKey = -1
	EndIf
	
	If !bUseVanillaHotkeys && (keyCode == pressedMappedKey) && IsModifierKeyPressed(pressedModifierKey) 
		MainScript.ExecuteHotkey(pressedHotkeyArrayIndex)
		;debug.notification("A mapped key was pressed at index " + tmpHotkeyArrayIndex)
		return
	EndIf
;/ 	While tmpHotkeyArrayIndex >= 0 && !MenuMode && aiSearchIndex < 1000 ;-- Just in case
		tmpHotkeyArrayIndex = JArray.findInt(MainScript.objHotkeyMappingArray,keyCode, aiSearchIndex)
		tmpMappedKey = JArray.getInt(MainScript.objHotkeyMappingArray,tmpHotkeyArrayIndex)
		tmpModifierKey = JArray.getInt(MainScript.objHotkeyModifierMappingArray,tmpHotkeyArrayIndex) ;-- NEW
		If !bUseVanillaHotkeys && (keyCode == tmpMappedKey) && IsModifierKeyPressed(tmpModifierKey) 
			MainScript.ExecuteHotkey(tmpHotkeyArrayIndex)
			;debug.notification("A mapped key was pressed at index " + tmpHotkeyArrayIndex)
			return
		else
			aiSearchIndex = tmpHotkeyArrayIndex + 1
		EndIf
	endwhile /;
EndEvent

Bool Function IsModifierKeyPressed(Int aiKey)
	If aiKey == -1
		return True
	Else
		return Input.IsKeyPressed(aiKey)
	EndIf
EndFunction

Event OnControlDown(String Control)
	tmpHotkeyArrayIndex = JArray.findStr(MainScript.objHotkeyMappingArray,Control)
	String strMappedKey = JArray.getStr(MainScript.objHotkeyMappingArray,tmpHotkeyArrayIndex)
	If (Control == strMappedKey) && !Utility.IsInMenuMode() && !UI.IsMenuOpen("LootMenu")
		MainScript.ExecuteHotkey(tmpHotkeyArrayIndex)
	EndIf
EndEvent
;========= MCM SELECTIONS ===========================================================
State LoadProfile1
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		If JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 1.json")
			MainScript.objSerioHotkeyModData = JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 1.json")
			DetermineKeysToRegister()
			ShowMessage("Profile Loaded",false)
		Else
			ShowMessage("Profile does not exist...",false)
		EndIf
	EndEvent
EndState
State LoadProfile2
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		If JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 2.json")
			MainScript.objSerioHotkeyModData = JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 2.json")
			DetermineKeysToRegister()
			ShowMessage("Profile Loaded",false)
		Else
			ShowMessage("Profile does not exist...",false)
		EndIf
	EndEvent
EndState
State LoadProfile3
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		If JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 3.json")
			MainScript.objSerioHotkeyModData = JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 3.json")
			DetermineKeysToRegister()
			ShowMessage("Profile Loaded",false)
		Else
			ShowMessage("Profile does not exist...",false)
		EndIf
	EndEvent
EndState
State LoadProfile4
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		If JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 4.json")
			MainScript.objSerioHotkeyModData = JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 4.json")
			DetermineKeysToRegister()
			ShowMessage("Profile Loaded",false)
		Else
			ShowMessage("Profile does not exist...",false)
		EndIf
	EndEvent
EndState
State LoadProfile5
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		If JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 5.json")
			MainScript.objSerioHotkeyModData = JValue.ReadFromFile(JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 5.json")
			ShowMessage("Profile Loaded",false)
		Else
			ShowMessage("Profile does not exist...",false)
		EndIf
	EndEvent
EndState


State SaveProfile1
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		JValue.WriteToFile(MainScript.objSerioHotkeyModData, JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 1.json")
		ShowMessage("Profile Saved",false)
	EndEvent
EndState
State SaveProfile2
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		JValue.WriteToFile(MainScript.objSerioHotkeyModData, JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 2.json")
		ShowMessage("Profile Saved",false)
	EndEvent
EndState
State SaveProfile3
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		JValue.WriteToFile(MainScript.objSerioHotkeyModData, JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 3.json")
		ShowMessage("Profile Saved",false)
	EndEvent
EndState
State SaveProfile4
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		JValue.WriteToFile(MainScript.objSerioHotkeyModData, JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 4.json")
		ShowMessage("Profile Saved",false)
	EndEvent
EndState
State SaveProfile5
	Event OnSelectST()
		MainScript.objTempData = JMap.Object() ; To append referenced data from objTempData
		JValue.WriteToFile(MainScript.objSerioHotkeyModData, JContainers.userDirectory() + "Serio's Hotkeys Data/Profile 5.json")
		ShowMessage("Profile Saved",false)
	EndEvent
EndState


State AddMoreHotkeys
	Event OnSelectST()
		If Jvalue.Count(MainScript.objHotkeyMappingArray) < 100
			MainScript.AddMoreHotkeys()
			ShowMessage("Hotkeys Added",false)
		Else 
			ShowMessage("Hotkey limit reached.",false)
		EndIf
	EndEvent
EndState
State CycleTimeout
	Event OnSliderOpenST()
		SetSliderDialogStartValue(fCycleTimeout)
		SetSliderDialogRange(0.0,60.0)
		SetSliderDialogInterval(0.5)
		SetSliderDialogDefaultValue(2.5)
	EndEvent
	Event OnSliderAcceptST(float akFloat)
		fCycleTimeout = akFloat
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("The amount of time that cycles take to revert back to the first cycle.")
	EndEvent
EndState

State bCycleResetNotification
	Event OnSelectST()
		bCycleResetNotification = !bCycleResetNotification
		SetToggleOptionValueST(bCycleResetNotification)
	EndEvent
	Event OnHighlightST()
		SetInfoText("Toggle the notification when cycles reset.")
	EndEvent
EndState

State VanillaHotkeyMapChange
	Event OnMenuOpenST()
		String[] strMapsMenu = new String[8]
		strMapsMenu[0] = "Hotkey1"
		strMapsMenu[1] = "Hotkey2"
		strMapsMenu[2] = "Hotkey3"
		strMapsMenu[3] = "Hotkey4"
		strMapsMenu[4] = "Hotkey5"
		strMapsMenu[5] = "Hotkey6"
		strMapsMenu[6] = "Hotkey7"
		strMapsMenu[7] = "Hotkey8"
		SetMenuDialogOptions(strMapsMenu)
		SetMenuDialogStartIndex(tmpHotkeyArrayIndex)
		SetMenuDialogDefaultIndex(0)
	EndEvent
	Event OnMenuAcceptST(int index)
		String[] strMapsMenu = new String[8]
		strMapsMenu[0] = "Hotkey1"
		strMapsMenu[1] = "Hotkey2"
		strMapsMenu[2] = "Hotkey3"
		strMapsMenu[3] = "Hotkey4"
		strMapsMenu[4] = "Hotkey5"
		strMapsMenu[5] = "Hotkey6"
		strMapsMenu[6] = "Hotkey7"
		strMapsMenu[7] = "Hotkey8"
		JArray.setStr(MainScript.objHotkeyMappingArray,tmpHotkeyArrayIndex,strMapsMenu[index])
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("Select the vanilla hotkey to associate with this hotkey.")
	EndEvent
EndState
State HotkeyChangeName
	Event OnInputAcceptST(string akString)
		JArray.setStr(MainScript.objHotkeyNamesArray,tmpHotkeyArrayIndex,akString)
		ForcePageReset()
	EndEvent
	Event OnDefaultST()
		JArray.setStr(MainScript.objHotkeyNamesArray,tmpHotkeyArrayIndex,"Hotkey " + (tmpHotkeyArrayIndex + 1))
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("Default: Reverts back to original name.")
	EndEvent
EndState
State HotkeyMenuOption
	Event OnMenuOpenST()
		String[] strNamesMenu = JArray.asStringArray(MainScript.objHotkeyNamesArray)
		SetMenuDialogOptions(strNamesMenu)
		SetMenuDialogStartIndex(0)
		SetMenuDialogDefaultIndex(0)
	EndEvent
	Event OnMenuAcceptST(int index)
		tmpHotkeyArrayIndex = index
		ForcePageReset()
	EndEvent

EndState
State HotkeyMapChange
	Event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
		;UnregisterForKey(tmpMappedKey)
		tmpMappedKey = keyCode
		SetKeyMapOptionValueST(tmpMappedKey)
		If tmpMappedKey > 0
			RegisterforKey(tmpMappedKey)
		EndIf
		JArray.setInt(MainScript.objHotkeyMappingArray,tmpHotkeyArrayIndex,tmpMappedKey)
	EndEvent
	
EndState
State HotkeyModifierMapChange ;-- NEW
	Event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
		;UnregisterForKey(tmpMappedKey) ;-- Probably shouldn't do this
		tmpModifierKey = keyCode
		SetKeyMapOptionValueST(tmpModifierKey)
		If tmpModifierKey > 0
			RegisterforKey(tmpModifierKey)
		EndIf
		JArray.setInt(MainScript.objHotkeyModifierMappingArray,tmpHotkeyArrayIndex,tmpModifierKey)
	EndEvent
	
EndState
State ResetData
	Event OnSelectST()
		JValue.clear(MainScript.objSerioHotkeyModData)
		MainScript.InitializeContainers()
		bUseVanillaHotkeys = false
		bExitOnReset = True
		ShowMessage("Data has been reset. Exit and return to MCM menu to set Hotkeys.",false)
		ForcePageReset()
	EndEvent
EndState

State UninstallMod
	Event OnSelectST()
		JValue.clear(MainScript.objSerioHotkeyModData)
		bUseVanillaHotkeys = false
		bExitOnReset = True
		bModEnabled = False
		ShowMessage("Hotkey data uninstalled. Please exit the MCM menu.",false)
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("Clears hotkey data and disables mod. Used for safe uninstallation of mod.")
	EndEvent
EndState
State ReinstallMod
	Event OnSelectST()
		MainScript.InitializeContainers()
		bExitOnReset = True
		bModEnabled = True
		ShowMessage("Hotkey data structure rebuilt. Exit and return to MCM menu to set Hotkeys.",false)
		ForcePageReset()
	EndEvent
EndState


Function RegisterForVanillaHotkeys()
	int i = 0 
	int UL = JValue.count(MainScript.objHotkeyMappingArray)
	While i < UL
		int akKey = JArray.getInt(MainScript.objHotkeyMappingArray,i)
		If akKey > 0
			UnregisterForKey(akKey)
		EndIf
		i += 1
	EndWhile
	i = 0 
	UL = JValue.count(MainScript.objHotkeyModifierMappingArray)
	While i < UL
		int akKey = JArray.getInt(MainScript.objHotkeyModifierMappingArray,i)
		If akKey > 0
			UnregisterForKey(akKey)
		EndIf
		i += 1
	EndWhile
	MainScript.objHotkeyData = MainScript.objVanillaHotkeyData
	RegisterForControl("Hotkey1")
	RegisterForControl("Hotkey2")
	RegisterForControl("Hotkey3")
	RegisterForControl("Hotkey4")
	RegisterForControl("Hotkey5")
	RegisterForControl("Hotkey6")
	RegisterForControl("Hotkey7")
	RegisterForControl("Hotkey8")
	If HotkeySetterKey > 0
		RegisterforKey(HotkeySetterKey)
	EndIf
	RegisterForKey(KEY_LALT)
	RegisterForKey(KEY_LCTRL)
EndFunction

Function RegisterForCustomHotkeys()
	MainScript.objHotkeyData = MainScript.objCustomHotkeyData
	int i = 0
	int UL = JValue.count(MainScript.objHotkeyMappingArray)
	While i < UL
		int akKey = JArray.getInt(MainScript.objHotkeyMappingArray,i)
		If akKey > 0
			RegisterForKey(akKey)
		EndIf
		i += 1
	EndWhile
	i = 0 
	UL = JValue.count(MainScript.objHotkeyModifierMappingArray)
	While i < UL
		int akKey = JArray.getInt(MainScript.objHotkeyModifierMappingArray,i)
		If akKey > 0
			RegisterForKey(akKey)
		EndIf
		i += 1
	EndWhile
	UnregisterForControl("Hotkey1")
	UnregisterForControl("Hotkey2")
	UnregisterForControl("Hotkey3")
	UnregisterForControl("Hotkey4")
	UnregisterForControl("Hotkey5")
	UnregisterForControl("Hotkey6")
	UnregisterForControl("Hotkey7")
	UnregisterForControl("Hotkey8")
	If HotkeySetterKey > 0
		RegisterforKey(HotkeySetterKey)
	EndIf
	RegisterForKey(KEY_LALT)
	RegisterForKey(KEY_LCTRL)
EndFunction

Function DetermineKeysToRegister()
	If bUseVanillaHotkeys
		RegisterForVanillaHotkeys()
	Else
		RegisterForCustomHotkeys()
	EndIf
EndFunction

State bUseVanillaHotkeys
	Event OnSelectST()
		If !bUseVanillaHotkeys
			Bool cancel = !ShowMessage("WARNING: This function does not override vanilla hotkeys. Unmap items from any vanilla hotkey that will be used with this mod.")
			If cancel
				return
			EndIf
		EndIf
		bUseVanillaHotkeys = !bUseVanillaHotkeys
		DetermineKeysToRegister()
		SetToggleOptionValueST(bUseVanillaHotkeys)
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("Switch functionality to use vanilla hotkeys instead of user defined hotkeys. Useful for GAMEPAD.")
	EndEvent
EndState
State HotkeySetterKey
	Event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
		HotkeySetterKey = keyCode
		SetKeyMapOptionValueST(HotkeySetterKey)
		RegisterforKey(HotkeySetterKey)
	EndEvent
	Event OnHighlightST()
		SetInfoText("This is the key that will be used to set equipment to all of the other hotkeys.")
	EndEvent
EndState
State bDoLCtrlForSetter
	Event OnSelectST()
		bDoLCtrlForSetter = !bDoLCtrlForSetter
		SetToggleOptionValueST(bDoLCtrlForSetter)
	EndEvent
EndState
State bDoLAltForSetter
	Event OnSelectST()
		bDoLAltForSetter = !bDoLAltForSetter
		SetToggleOptionValueST(bDoLAltForSetter)
	EndEvent
EndState